$!-----------------------------------------------------------------------------
$! BUILD_SOYMAIL.COM
$!
$! Build the soyMAIL executable.
$!
$! P1-4 == BUILD, COMPILE, LINK or empty (builds)
$!
$! 08-MAR-2006  MGD  workaround system logical LANG and lang.c module
$! 01-FEB-2005  MGD  initial (soymail)
$!-----------------------------------------------------------------------------
$!
$ IF P1 .EQS. "DIST"
$ THEN
$!   (distribution build - not used on your average site)
$    @BUILD_SOYMAIL
$    EXIT
$ ENDIF
$!
$!(marshal the build parameters)
$ BUILD = "BUILD"
$ IF P1 .EQS. "BUILD" THEN BUILD = P1
$ IF P2 .EQS. "BUILD" THEN BUILD = P2
$ IF P3 .EQS. "BUILD" THEN BUILD = P3
$ IF P4 .EQS. "BUILD" THEN BUILD = P4
$ IF P1 .EQS. "COMPILE" THEN BUILD = P1
$ IF P2 .EQS. "COMPILE" THEN BUILD = P2
$ IF P3 .EQS. "COMPILE" THEN BUILD = P3
$ IF P4 .EQS. "COMPILE" THEN BUILD = P4
$ IF P1 .EQS. "LINK" THEN BUILD = P1
$ IF P2 .EQS. "LINK" THEN BUILD = P2
$ IF P3 .EQS. "LINK" THEN BUILD = P3
$ IF P4 .EQS. "LINK" THEN BUILD = P4
$ JUST = ""
$ IF F$ELEMENT(0,":",P1) .EQS. "JUST" THEN JUST = F$ELEMENT(1,":",P1)
$ IF F$ELEMENT(0,":",P2) .EQS. "JUST" THEN JUST = F$ELEMENT(1,":",P2)
$ IF F$ELEMENT(0,":",P3) .EQS. "JUST" THEN JUST = F$ELEMENT(1,":",P3)
$ IF F$ELEMENT(0,":",P4) .EQS. "JUST" THEN JUST = F$ELEMENT(1,":",P4)
$!
$ DATETIME = F$TIME()
$ IF F$EXTRACT(0,1,DATETIME) .EQS. " " THEN DATETIME = F$EXTRACT(1,99,DATETIME)
$!
$ ON CONTROLY THEN EXIT 44
$!
$ WRITE SYS$OUTPUT ""
$ WRITE SYS$OUTPUT "Building ""soyMAIL"" for ""''F$GETSYI("ARCH_NAME")'"""
$!
$ ARCH_NAME = F$EDIT(F$GETSYI("ARCH_NAME"),"UPCASE")
$ IF ARCH_NAME .EQS. "ALPHA" THEN ARCH_NAME = "AXP"
$!
$ CC_DEFINES = "/DEFINE=(SOYMAIL_VMS_V6,BUILD_DATETIME=""""""''DATETIME'"""""")"
$!
$ LINK_OPTIONS = F$SEARCH("SOYMAIL_''ARCH_NAME'.OPT")
$ IF LINK_OPTIONS .NES. "" -
     THEN LINK_OPTIONS = "," + F$ELEMENT(0,";",LINK_OPTIONS) + "/OPTIONS"
$!
$ IF F$SEARCH("OBJ_''ARCH_NAME'.DIR") .EQS. "" -
     THEN CREATE/DIR [.OBJ_'ARCH_NAME']
$ OBJECT_DIR = "[.OBJ_''ARCH_NAME']"
$!
$ IF JUST .EQS. "" .AND. BUILD .NES. "LINK"
$ THEN
$    DELETE = "DELETE/LOG"
$    DELETE 'OBJECT_DIR'*.OBJ;*
$ ENDIF
$!
$ IF F$EDIT(F$GETSYI("ARCH_NAME"),"UPCASE") .EQS. "VAX"
$ THEN
$    CC_OPTIONS = "/DECC /OPT /STAND=RELAXED /PREFIX=ALL /INC=[]"
$ ELSE
$    CC_OPTIONS = "/DECC /OPT /STAND=RELAXED /PREFIX=ALL /INC=[] "
$ ENDIF
$!
$ IF BUILD .EQS. "BUILD" .OR. BUILD .EQS. "COMPILE"
$ THEN
$    SET NOON
$    SET VERIFY
$!(compile soymail components)
$ IF JUST .NES. "" THEN GOTO 'JUST'
$ ADDRESS:
$ CC 'CC_OPTIONS' 'CC_DEFINES' /OBJ='OBJECT_DIR' address
$ IF JUST .NES. "" THEN GOTO END_JUST
$ ATTACH:
$ CC 'CC_OPTIONS' 'CC_DEFINES' /OBJ='OBJECT_DIR' attach
$ IF JUST .NES. "" THEN GOTO END_JUST
$ CALLMAIL:
$ CC 'CC_OPTIONS' 'CC_DEFINES' /OBJ='OBJECT_DIR' CallMail
$ IF JUST .NES. "" THEN GOTO END_JUST
$ CEREAL:
$ CC 'CC_OPTIONS' 'CC_DEFINES' /OBJ='OBJECT_DIR' cereal
$ IF JUST .NES. "" THEN GOTO END_JUST
$ CGILIB:
$ CC 'CC_OPTIONS' 'CC_DEFINES' /OBJ='OBJECT_DIR' CGILIB
$ IF JUST .NES. "" THEN GOTO END_JUST
$ COMPOSE:
$ CC 'CC_OPTIONS' 'CC_DEFINES' /OBJ='OBJECT_DIR' compose
$ IF JUST .NES. "" THEN GOTO END_JUST
$ CONFIG:
$ CC 'CC_OPTIONS' 'CC_DEFINES' /OBJ='OBJECT_DIR' config
$ IF JUST .NES. "" THEN GOTO END_JUST
$ CONTACTS:
$ CC 'CC_OPTIONS' 'CC_DEFINES' /OBJ='OBJECT_DIR' contacts
$ IF JUST .NES. "" THEN GOTO END_JUST
$ FOLDER:
$ CC 'CC_OPTIONS' 'CC_DEFINES' /OBJ='OBJECT_DIR' folder
$ IF JUST .NES. "" THEN GOTO END_JUST
$ GMT:
$ CC 'CC_OPTIONS' 'CC_DEFINES' /OBJ='OBJECT_DIR' gmt
$ IF JUST .NES. "" THEN GOTO END_JUST
$ HELP:
$ CC 'CC_OPTIONS' 'CC_DEFINES' /OBJ='OBJECT_DIR' help
$ IF JUST .NES. "" THEN GOTO END_JUST
$ HTML:
$ CC 'CC_OPTIONS' 'CC_DEFINES' /OBJ='OBJECT_DIR' html
$ IF JUST .NES. "" THEN GOTO END_JUST
$ INETMAIL:
$ CC 'CC_OPTIONS' 'CC_DEFINES' /OBJ='OBJECT_DIR' inetmail
$ IF JUST .NES. "" THEN GOTO END_JUST
$ LANG:
$ CC 'CC_OPTIONS' 'CC_DEFINES' /OBJ='OBJECT_DIR' []lang
$ IF JUST .NES. "" THEN GOTO END_JUST
$ MAINMENU:
$ CC 'CC_OPTIONS' 'CC_DEFINES' /OBJ='OBJECT_DIR' mainmenu
$ IF JUST .NES. "" THEN GOTO END_JUST
$ MESSAGE:
$ CC 'CC_OPTIONS' 'CC_DEFINES' /OBJ='OBJECT_DIR' message
$ IF JUST .NES. "" THEN GOTO END_JUST
$ MIMEDEC:
$ CC 'CC_OPTIONS' 'CC_DEFINES' /OBJ='OBJECT_DIR' mimedec
$ IF JUST .NES. "" THEN GOTO END_JUST
$ MIMEENC:
$ CC 'CC_OPTIONS' 'CC_DEFINES' /OBJ='OBJECT_DIR' mimeenc
$ IF JUST .NES. "" THEN GOTO END_JUST
$ MTA:
$ CC 'CC_OPTIONS' 'CC_DEFINES' /OBJ='OBJECT_DIR' mta
$ IF JUST .NES. "" THEN GOTO END_JUST
$ NEWMAIL:
$ CC 'CC_OPTIONS' 'CC_DEFINES' /OBJ='OBJECT_DIR' newmail
$ IF JUST .NES. "" THEN GOTO END_JUST
$ OPTIONS:
$ CC 'CC_OPTIONS' 'CC_DEFINES' /OBJ='OBJECT_DIR' options
$ IF JUST .NES. "" THEN GOTO END_JUST
$ OTHER:
$ CC 'CC_OPTIONS' 'CC_DEFINES' /OBJ='OBJECT_DIR' other
$ IF JUST .NES. "" THEN GOTO END_JUST
$ PUBLIC:
$ CC 'CC_OPTIONS' 'CC_DEFINES' /OBJ='OBJECT_DIR' public
$ IF JUST .NES. "" THEN GOTO END_JUST
$ REGEX:
$ REGEX_DEFINES = CC_DEFINES - ")" + "," + "STDC_HEADERS,REGEX_MALLOC)"
$ CC 'CC_OPTIONS' 'REGEX_DEFINES' /OBJ='OBJECT_DIR' regex
$ IF JUST .NES. "" THEN GOTO END_JUST
$ REQUEST:
$ CC 'CC_OPTIONS' 'CC_DEFINES' /OBJ='OBJECT_DIR' request
$ IF JUST .NES. "" THEN GOTO END_JUST
$ SENDMAIL:
$ CC 'CC_OPTIONS' 'CC_DEFINES' /OBJ='OBJECT_DIR' sendmail
$ IF JUST .NES. "" THEN GOTO END_JUST
$ SOYMAIL:
$ CC 'CC_OPTIONS' 'CC_DEFINES' /OBJ='OBJECT_DIR' soyMAIL
$ IF JUST .NES. "" THEN GOTO END_JUST
$ SEARCH:
$ REGEX_DEFINES = CC_DEFINES - ")" + "," + "STDC_HEADERS,REGEX_MALLOC)"
$ CC 'CC_OPTIONS' 'REGEX_DEFINES' /OBJ='OBJECT_DIR' search
$ IF JUST .NES. "" THEN GOTO END_JUST
$!
$ ENDIF
$!
$ IF BUILD .EQS. "BUILD" .OR. BUILD .EQS. "LINK"
$ THEN
$    LINK_OPTIONS = ""
$    SET NOON
$    SET VERIFY
$!   (linking vanilla version)
$ LINK/NOTRACE/EXECUTABLE='OBJECT_DIR'SOYMAIL.EXE -
  'OBJECT_DIR'ADDRESS,attach,callmail,cereal,CGILIB,compose,config,-
     contacts,folder,GMT,help,HTML,inetmail,'OBJECT_DIR'lang,mainmenu,message,-
     mimedec,newmail,mimeenc,mta,options,other,public,regex,request,-
     sendmail,soyMAIL,search
$!   'F$VERIFY(0)
$    SET ON
$ ENDIF
$ PURGE/NOLOG 'OBJECT_DIR'
$ END_JUST:
$!'F$VERIFY(0)
$!
$!-----------------------------------------------------------------------------
